<?php if(!defined('IN_GS')){ die('you cannot load this page directly.'); }
/*
Coa 1.1
Copyright © 2012 Benjamin Scherer 
www.plue.me
*/



/*
Current page id
*/
$curPid = $_GET['id']; 
if (!$curPid) $curPid = 'index';





/*
Parse template
These functions parse Coa files to object arrays and initiate the rendering
*/


/* Get Objects
 * since 1.0 */

function getObjects($path) {
	$file = file($path);
	$OBJ = array();
	
	// go through each line of the file
	foreach($file as $key => $line) {

		// define objects and comment
		$providedObj = preg_match('/^main|^meta|^css|^script|^text|^menu|^image|^place|^content|^config/i', trim($line));
		$comment = '/^#/';
		
		// check for objects
		if ($providedObj && !preg_match($comment, trim($line))) {
		
				// get object type -> write to array
				$objType = trim($line);
				$objA = array();
				$objA['type'] = $objType;
					
				// get object length
				for ($i=$key; $i<$key+15; $i++) {	
					if (!trim($file[$i])) {
						$objLength = $i-$key;
						break;
					}
				}
				
				// get attributes and values -> write to array
				for ($k=$key; $k<$key+$objLength; $k++) {
					if (trim($file[$k]) !== '' && !preg_match($comment, trim($file[$k]))) {	
						$attrLine = explode('=', trim($file[$k]), 2);
						$objA[trim($attrLine[0])] = trim($attrLine[1]);	
					}
				}
				
				// push objects to array
				array_push($OBJ, $objA);
		}
	}
	
	// return objects
	return $OBJ;
}



/* Get Attributes
 * since 1.0 */

function getAttributes($OA,$curPid) {
		
		// default attributes which keep their name, 
		// e.g. $OA['value'] are available automatically
		
		// get 'wrap'
		$OA['wrapB'] = wrapB($OA['wrap']);
		$OA['wrapA'] = wrapA($OA['wrap']);

		// get 'link'			
		$l = $OA['link'];
		$OA['linkIs'] = 0;
		
		if ($l) {
			// if link has target
			if (preg_match('/,/', $l)) {
				$OA['link'] = commaB($l);
				$OA['linkT'] = commaA($l);
			} else {
				$OA['link'] = trim($l);
				$OA['linkT'] = '_top';
			}
			$OA['linkIs'] = 1; 
		}
			
		// get 'list'
		#$OA['listA'] = explode(',', $OA['list']);
			
		// get 'item'
		$OA['itemB'] = wrapB($OA['item']);
		$OA['itemA'] = wrapA($OA['item']);
			
		// get 'cur'
		$OA['curB'] = wrapB($OA['cur']);
		$OA['curA'] = wrapA($OA['cur']);
			
		// get 'act'
		$OA['actB'] = wrapB($OA['act']);
		$OA['actA'] = wrapA($OA['act']);
		
		// get 'size'
		$OA['width'] = commaB($OA['size']);
		$OA['height'] = commaA($OA['size']);

		// get prepared for 'css' nad 'script' attributes
		$OA_ = $OA;
		$OA['all'] = array();
		$OA['screen'] = array();
		$OA['print'] = array();
		$OA['js'] = array();
		
		// get 'all', 'screen', 'print' and 'js'
		if ($OA_['all']) $OA['all'][0] = $OA_['all'];
		if ($OA_['screen']) $OA['screen'][0] = $OA_['screen'];
		if ($OA_['print']) $OA['print'][0] = $OA_['print'];
		if ($OA_['js']) $OA['js'][0] = $OA_['js'];
		
		// get 'all[1-9]', 'screen[1-9]', 'print[1-9]' and 'js[1-9]'
		for ($k=1; $k<10; $k++) {
			if ($OA['all'.$k]) {
				$OA['all'][$k] = $OA['all'.$k];
				unset($OA['all'.$k]);
			}
			if ($OA['screen'.$k]) {
				$OA['screen'][$k] = $OA['screen'.$k];
				unset($OA['screen'.$k]);
			}
			if ($OA['print'.$k]) {
				$OA['print'][$k] = $OA['print'.$k];
				unset($OA['print'.$k]);
			}
			if ($OA['js'.$k]) {
				$OA['js'][$k] = $OA['js'.$k];
				unset($OA['js'.$k]);
			}
		}


	
		///////////////////////////////
		// get conditions
		//////////////////////////////
		
		$onlyA = explode(',', $OA['only']);
		$exclA = explode(',', $OA['exclude']);

		$ifSub = 0; $ifNoSub = 0;
		if ($OA['if'] == 'sub') $ifSub = 1;
		if ($OA['if'] == '!sub') $ifNoSub = 1; 
		
		
		///////////////////////////////
		// check conditions
		//////////////////////////////
		
		// reset allTrue
		$OA['allTrue'] = 0;
		
		// 'only','exclude' and 'if' are fine with this object
		if ($OA['only']) {
			if (in_array($curPid, $onlyA) && !in_array($curPid, $exclA)) {
				if ($ifSub && return_parent() != '' || $ifNoSub && return_parent() == '')
					$OA['allTrue'] = 1;
				elseif (!$ifSub && !$ifNoSub)
					$OA['allTrue'] = 1;
			} 
		} elseif (!in_array($curPid, $exclA)) {
			if ($ifSub && return_parent() != '' || $ifNoSub && return_parent() == '')
				$OA['allTrue'] = 1;
			elseif (!$ifSub && !$ifNoSub)
				$OA['allTrue'] = 1;
		}
		
		// filter array
		$OA = array_filter($OA);
		
		// return object array
		return $OA;	

}




/* Get Config Object
 * since 1.0 */

function configObj($path) {
	global $curPid;
	global $USR;
	
	// get constant objects and lenght
	$OBJ = getObjects($path);
	$objLength = count($OBJ);
	
	// create arrays
	$OA = array();
	$configOA = array();

	// for each object
	for ($i=0; $i<$objLength; $i++) {

		// create $OA and get attributes
		$OA = $OBJ[$i];
		$OA = getAttributes($OA,$curPid);


		///////////////////////////////
		// make config object
		//////////////////////////////
		
		if ($OA['allTrue'] == 1 && $OA['type'] == 'config') {
				
				// require Login
				if ($OA['loginReq'] == 1 && !$USR) 
					header('location:'.get_site_url(false).'admin/index.php?redirect='.$_SERVER['REQUEST_URI']);
				
				// wrap page
				$configOA['wrapPageB'] = wrapB($OA['wrapPage']);
				$configOA['wrapPageA'] = wrapA($OA['wrapPage']);
				
				// minify source
				$configOA['minify'] = $OA['minify'];
				
				// html tag
				$configOA['htmlTag'] = $OA['htmlTag'];
				
				// caching
				$configOA['cache'] = $OA['cache'];
				
				// protect mail addresses
				$configOA['protMail'] = $OA['protMail'];
		}	
	
	}
	
	// return config
	return $configOA;

}




/* Parse Constant Objects
 * since 1.0 */

function makeConstant($pathConstant, $configOA) {
	global $curPid;
	
	// get constant objects and lenght
	$OBJ = getObjects($pathConstant);
	$objLength = count($OBJ);
	
	// for each object
	for ($i=0; $i<$objLength; $i++) {
		
		// create object array
		$OA = array();
		$OA = $OBJ[$i];
		
		// get attributes
		$OA = getAttributes($OA,$curPid);


		///////////////////////////////
		// make objects
		//////////////////////////////
		
		if ($OA['allTrue'] == 1) {
		
			if ($OA['type'] == 'main') {
				if (!$OA['language']) $OA['language'] = 'en';
				mainObj($OA,$configOA);
			}
		
			if ($OA['type'] == 'meta') metaObj($OA);
			if ($OA['type'] == 'css') cssObj($OA);
			if ($OA['type'] == 'script') scriptObj($OA);
			if ($OA['type'] == 'text') textObj($OA);
		}	
	
	}
	
	// return header end
	headEnd($configOA);
}



/* Parse Page Objects
 * since 1.0 */

function makePage($path, $configOA, $isPlace) {
	global $curPid;

	// get template objects and lenght
	$OBJ = getObjects($path);
	$objLength = count($OBJ);
	
	// for each object
	for ($i=0; $i<$objLength; $i++) {
		
		// create object array
		$OA = array();
		$OA = $OBJ[$i];
		
		// get attributes
		$OA = getAttributes($OA,$curPid);


		///////////////////////////////
		// make objects
		//////////////////////////////
		
		if ($OA['allTrue'] == 1) {
			if ($OA['type'] == 'text') textObj($OA);
			if ($OA['type'] == 'menu') menuObj($OA);
			if ($OA['type'] == 'image') imageObj($OA);	

			if ($OA['type'] == 'content') {
				echo $OA['wrapB'];
				if ($OA['get'] == 'one' || !$OA['get']) get_page_content();
				else get_component($OA['get']);
				echo $OA['wrapA']; 
			}
		
			if ($OA['type'] == 'place') placeObj($OA);
			if ($OA['type'] == 'script') {
				echo "\n";
				scriptObj($OA);
			}
		}
	
	}
	
	
	///////////////////////////////
	// echo document end
	//////////////////////////////
	
	if ($isPlace == 0) {
	
		// wrap page
		if ($configOA['wrapPageB']) echo "\n".$configOA['wrapPageA']."\n";
		else echo "\n";
		
		// GS footer
		get_footer();
		
		// mail protection
		mailToJS($configOA);
		
		// end tags
		echo '</body>'."\n".'</html>';
	}
	
}



/* wrapB and wrapA
 * since 1.0 */
 
function wrapB($x) {
	return trim(substr($x, 0, strpos($x, '|')));
}

function wrapA($x) {
	return trim(substr($x, strpos($x, '|')+1));
}



/* commaB and commaA
 * since 1.0 */
 
function commaB($x) {
	return trim(substr($x, 0, strpos($x, ',')));
}

function commaA($x) {
	return trim(substr($x, strpos($x, ',')+1));
}



/* Get config object
 * since 1.0 */
 
$configOA = configObj($pathConstant);







/*
Protect Mail
These functions protect email addresses and links
*/



/* Distort Mail (for links only)
 * since 1.0 */

function distortMail($mail) {
		
		// define condition
		$character_set = '+-.0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz';
		$key = str_shuffle($character_set); 
		$cipher_text = ''; 
		#$id = 'e'.rand(1,999999999);
		
		// distort
		for($i=0;$i<strlen($mail);$i+=1) 
				$cipher_text.= $key[strpos($character_set,$mail[$i])];
		
		// change a tag 
  	$onlick = 'href="javascript:return false" onclick="mailTo('."'".$key."','".$cipher_text."')";
		return $onlick;
}



/* Replace MailTo
 * since 1.0 */

function replaceMailTo($buffer) {

		// search for – and cut – mailto:
    $buffer = preg_replace_callback(
        '|(href="mailto:)([a-zA-Z0-9_.-]+@[a-zA-Z0-9-]+.[a-zA-Z0-9-.]+)([a-zA-Z?=%&;0-9-.]*)|',
        create_function(
            '$matches',
            'return distortMail($matches[2]);'
        ), $buffer
		);
    return $buffer;
}
if ($configOA['protMail'] == 2)
		ob_start('replaceMailTo');



/* Replace Mail with ASCII
 * since 1.0 */

function replaceMail($buffer) {
    $buffer = preg_replace_callback(
        '|(%)([a-zA-Z0-9_.-]+)(@)([a-zA-Z0-9-]+)(.)([a-zA-Z0-9-.]+)(%)|',
        create_function(
            '$matches',
            'return $matches[2].\'<span>&#064;</span>\'.$matches[4].\'<span>&#046;</span>\'.$matches[6];'
        ), $buffer
		);
    return $buffer;
}
if ($configOA['protMail'] == 1 || $configOA['protMail'] == 2)
		ob_start('replaceMail');



/* Protect Mail JavaScript
 * since 1.0 */

function mailToJS($configOA) {
		
		$script = 'function mailTo(a,c){var b=a.split("").sort().join("");var d="";for(var e=0;e<c.length;e++)d+=b.charAt(a.indexOf(c.charAt(e)));window.location.href="mailto:"+d}';
		
		if ($configOA['protMail'] == 2)   
				echo '<script>/*<![CDATA[*/'.$script.'/*]]>*/</script>'."\n";
}








/*
Cache
These functions cache and compress the HTML output
*/



/* Minify
 * since 1.0 */

function minify($buffer) {
    $search = array (
        '/\>[^\S ]+/s', // strip whitespaces after tags, except space
        '/[^\S ]+\</s', // strip whitespaces before tags, except space
        '/(\s)+/s'  // shorten multiple whitespace sequences
        );
    $replace = array (
        '>',
        '<',
        '\\1'
        );
  	$buffer = preg_replace($search, $replace, $buffer);
	return $buffer;
}



/* Cache and Minify
 * since 1.0 */

if ($USR || !$configOA['cache']) $configOA['cache'] = 0;

if ($configOA['cache'] == 1) {

	// create folder
	mkdir(dirname(__FILE__).'/cache', 0770);
	
	// cache directory and file
	$cachedir = dirname(__FILE__) .'/cache/';
	if (basename($_SERVER['REQUEST_URI']) == '') define('CACHFILE', $cachedir . 'index');
	else define('CACHFILE', $cachedir . basename($_SERVER['REQUEST_URI']));

	// cachefile found
	if(is_file(CACHFILE)) {
		readfile(CACHFILE);
		exit;
	}
 
	// cachefile not found
	ob_start('cacheCallback');

	// compression
	if ($configOA['minify'] == 1)
		ob_start('minify');

// else, caching is off
} else {
	$clearDir = dirname(__FILE__) .'/cache/*';
	
	// clear cache
	foreach(glob($clearDir) as $v){
	    unlink($v);
	}
	
	// compression
	if ($configOA['minify'] == 1)
			ob_start('minify');
}



/* Cache Callback
 * since 1.0 */
 
function cacheCallback($buffer) {
	if(!is_file(CACHFILE)) {
		file_put_contents(CACHFILE,$buffer);
	}
 	return $buffer;
}







/*
Make Constant
These functions echo the HTML Header
*/



/* Main Object
 * since 1.0 */

function mainObj($OA,$configOA) {
			
	// globalsGS
	global $title;
	global $SITENAME;
	global $pathTheme;
	
	// vars
	$cB = '<!--[if ';
	$cE = '<![endif]-->';
	
	// doctype and attribute "language"
	$htmlB = '<html lang="' .$OA['language'];
	echo '<!doctype html>'."\n";
	
	if ($configOA['htmlTag'] == 'ieClass') {
		echo $cB.'lt IE 7 ]>' .$htmlB. '" class="ie ie6 no-js">'.$cE."\n".
		 	$cB.'IE 7 ]>' .$htmlB. '" class="ie ie7 no-js">'.$cE."\n".
			$cB.'IE 8 ]>' .$htmlB. '" class="ie ie8 no-js">'.$cE."\n".
		 	$cB.'IE 9 ]>' .$htmlB. '" class="ie ie9 no-js">'.$cE."\n".
		 	$cB.'(gt IE 9)|!(IE)]><!-->' .$htmlB. '" class="no-js"><!--'.$cE;
	} elseif ($configOA['htmlTag']) {
		echo $configOA['htmlTag'];
	} else {
		echo $htmlB.'">';
	}
			
	// header begin
	echo "\n".'<head>'."\n";
	
	// attribute "charset"
	if ($OA['charset']) 
		echo '<meta charset="'. $OA['charset'] .'">'."\n";
				
	// page title
	echo '<title>';
	$site = trim(stripslashes($SITENAME));
	$page = strip_tags(strip_decode($title));
	$temp = str_replace('%page', $page, $OA['title']);
	echo str_replace('%site', $site, $temp);
	echo '</title>'."\n";
			
	// attribute "base" 
	if (!$OA['base']) {
		echo '<base href="';
		get_site_url();
		echo '">'."\n";
	} else {
		echo '<base href="' .$OA['base']. '">'."\n";
	}
	
	// attribute "favicon"
	if ($OA['favicon'])
		echo '<link rel="shortcut icon" href="'. $pathTheme.$OA['favicon'] .'">'."\n";
	
}



/* Meta Object
 * since 1.0 */

function metaObj($OA) {
	
	$metaB = '<meta name="';
		
	// attribute "viewport"
	if ($OA['viewport'])
		echo $metaB.'viewport" content="'. $OA['viewport'] .'">'."\n";
			
	// attribute "robots"
	if ($OA['robots'])
		echo $metaB.'robots" content="'. $OA['robots'] .'">'."\n";
			
	// attribute "description"
	if ($OA['description'])
		echo $metaB.'description" content="'. $OA['description'] .'">'."\n";
			
	// attribute "kewords"
	if ($OA['keywords'])
		echo $metaB.'keywords" content="'. $OA['keywords'] .'">'."\n";
	
	// GS header as default	
	if(!$OA['headerGS']) $OA['headerGS']=1;
	
	// GS header or canonical
	if($OA['headerGS'] == 1) get_header();
	else echo '<link rel="canonical" href="'.get_page_url(true).'">'."\n";

}



/* CSS Object
 * since 1.0 */

function cssObj($OA) {
	global $pathTheme;
	$cssB = '<link rel="stylesheet" href="';
			
	// attribute 'all', 'print' and 'screen'
	for ($k=0; $k<10; $k++) {
		if ($OA['all'][$k]) {
		
			// check for absolute path
			if (substr($OA['all'][$k],0,4) == 'http') $pathT = '';
			else $pathT = $pathTheme;
			
			echo $OA['wrapB'].$cssB. $pathT . $OA['all'][$k] .'">'.$OA['wrapA']."\n";
		}
			
		if ($OA['print'][$k]) {
			
			// check for absolute path
			if (substr($OA['print'][$k],0,4) == 'http') $pathT = '';
			else $pathT = $pathTheme;
			
			echo $OA['wrapB'].$cssB. $pathT . $OA['print'][$k] .'" media="print">'.$OA['wrapA']."\n";
		}
			
		if ($OA['screen'][$k]) {
		
			// check for absolute path
			if (substr($OA['screen'][$k],0,4) == 'http') $pathT = '';
			else $pathT = $pathTheme;
			
			echo $OA['wrapB'].$cssB. $pathT . $OA['screen'][$k] .'" media="screen">'.$OA['wrapA']."\n";
		}
	}
}



/* Script Object
 * since 1.0 */

function scriptObj($OA) {
	global $pathTheme;
			
	// attribute 'js'
	for ($k=0; $k<10; $k++) {
		if ($OA['js'][$k]) {
			
			// check for absolute path
			if (substr($OA['js'][$k],0,4) == 'http') $pathT = '';
			else $pathT = $pathTheme;
			
			echo $OA['wrapB']. '<script src="' . $pathT . $OA['js'][$k] .'"></script>'.$OA['wrapA']."\n";
		}
	}
}



/* Header End
 * since 1.0 */

function headEnd($configOA) {
	global $url;
	
	echo '</head>'."\n".'<body id="'.$url.'">'."\n";
	if ($configOA['wrapPageB']) echo $configOA['wrapPageB']."\n";
}







/*
Make Page
These functions echo the HTML Template
*/



/* Text Objects
 * since 1.0 */

function textObj($OA) {
	
	// echo 'wrap' before
	echo $OA['wrapB'];
					
	// echo 'link' begin
	if ($OA['linkIs'] == 1)
		echo '<a href="'. $OA['link'] .'" target="'. $OA['linkT'] .'">';
	
	// echo 'data'
	$d = $OA['data'];
	$dB = commaB($d);
	$dA = commaA($d);
	
	if ($d == 'cleanTitle') { get_page_clean_title(); }
	if ($d == 'title') { get_page_title(); }
	if ($d == 'slug') { get_page_slug(); }
	if ($d == 'excerpt') { get_page_excerpt(); }
	if ($d == 'keywords') { get_page_meta_keywords(); }
	if ($d == 'description') { get_page_meta_desc(); }
	if ($d == 'parent') { get_parent(); }
	if ($d == 'url') { get_page_url(); }
	if ($d == 'theme') { get_theme_url(); }
	if ($d == 'name') { get_site_name(); }
	#if ($d == 'mail') { get_site_email(); }
	if ($d == 'date') { get_page_date(); }
	if ($dB == 'date') { get_page_date($dA); }
					
	// echo 'value'
	$v = $OA['value'];
	$v = str_replace('%title', get_page_title(false), $v);
	$v = str_replace('%cleanTitle', get_page_clean_title(false), $v);
	$v = str_replace('%title', get_page_title(false), $v);
	$v = str_replace('%slug', get_page_slug(false), $v);
	$v = str_replace('%keywords', get_page_meta_keywords(false), $v);
	$v = str_replace('%description', get_page_meta_desc(false), $v);
	$v = str_replace('%parent', get_parent(false), $v);
	$v = str_replace('%theme', get_theme_url(false), $v);
	$v = str_replace('%name', get_site_name(false), $v);	
	echo $v;
					
	// echo 'link' end
	if ($OA['linkIs'] == 1)
		echo '</a>';
					
	// echo 'wrap' after
	echo $OA['wrapA']."\n"; 	
}



/* Image Object 
 * since 1.0 */ 

function imageObj($OA) {
	global $pathTheme;

	// 'wrap' before
	if ($OA['wrapB']) echo $OA['wrapB']."\n";
					
	// if 'link' exists
	if ($OA['linkIs'] == 1)
		echo '<a href="'. $OA['link'] .'" target="'. $OA['linkT'] .'">';
		
	// check for absolute path
	if (substr($OA['file'],0,4) == 'http') $pT = '';
	else $pT = $pathTheme;
	
	// check what exists...
	if ($OA['width']) {
		echo '<img src="'. $pT . $OA['file'] .'"';
		if ($OA['width'] != 'auto') echo ' width="'. $OA['width'] .'"';
		if ($OA['height'] != 'auto') echo ' height="'. $OA['height'] .'"';
		echo ' alt="'. $OA['alt'] .'"';
		if ($OA['title']) echo ' title="'. $OA['title'] .'"';
		echo '>';
	} else {
		echo '<img src="'. $pT . $OA['file'] .'" alt="'. $OA['alt'] .'"';
		if ($OA['title']) echo ' title="'. $OA['title'] .'"';
		echo '>';
	}
					
	// if 'link' exists
	if ($OA['linkIs'] == 1)
		echo '</a>';
					
	// 'wrap' after
	if ($OA['wrapA']) echo "\n".$OA['wrapA'];
	echo "\n";
}



/* Place Object
 * since 1.0 */
		
function placeObj($OA) {
	global $pathTheme;
	
	// 'wrap' before
	echo $OA['wrapB'];
	
	// get file suffix
	$last4 = substr($OA['file'], -4);
	$last5 = substr($OA['file'], -5);
	$last8 = substr($OA['file'], -8);

	// check file type
	if ($last4 == '.coa' || $last8 == '.coa.php')
		makePage($pathTheme.$OA['file'], 1);
		
	elseif ($last4 == '.php' || $last4 = '.htm' || $last5 == '.html')
		include_once($pathTheme.$OA['file']);
	
	// 'wrap' end
	echo $OA['wrapA']."\n";

}



/* Menu Object 
 * since 1.0 */

function menuObj($OA) {
	global $curPid;

	// menu 'wrap' begin
	if (!$OA['wrapB']) echo '<ul>';
	echo $OA['wrapB']."\n";
	
	// make default menu
	if ($OA['mode'] == 'default') get_navigation(get_page_slug(false));
	
	// make breadcrump
	elseif ($OA['mode'] == 'breadcrump') makeBread(return_page_slug(false),1,$OA);
	
	// make hierachical menu
	else makeLi(return_page_slug(false),$OA);

	// menu 'wrap' wrap
	if (!$OA['wrapA']) echo '</ul>';
	echo $OA['wrapA']."\n";
}



/* Make <li> Tags 
 * since 1.0 */

// original is get_navigation() from 'admin/inc/theme_functions.php'
function makeLi($currentpage,$OA) {
	global $pagesArray;
	$menu = '';
	$pagesSorted = subval_sort($pagesArray,'menuOrder');
	
	// for each page
	if (count($pagesSorted) != 0) { 
		foreach ($pagesSorted as $page) {
			/* $sel = ''; $classes = ''; */
			if ($page['menuStatus'] == 'Y') { 
				
				// if no menu title / page title
				if (!$page['menu']) $page['menu'] = $page['title'];
				if (!$page['title']) $page['title'] = $page['menu'];

				// if no parent, make <li> and go for sub
				if (!$page['parent']) {
					
					// make <li> tags and go for sub
					$menu.= liTag($currentpage,$page,$OA,0).'<a href="'.find_url($page['url'],$page['parent']).'"';
					
					// if title is 'none'
					if ($OA['title'] == 'none') $nothing = 'happens';
					else $menu.= ' title="'.strip_quotes($page['title']).'"';
					
					$menu.= '>'.$page['menu'].'</a>';
						
					$makeSub = makeSub($page['url'],$currentpage,$OA);
					
					if ($makeSub) $menu .= '<ul>'.$makeSub.'</ul>'; 
					$menu .= liTag($currentpage,$page,$OA,1)."\n";
				}		
			}
		}
	}
	echo exec_filter('menuitems',$menu);
}



/* Make Submenu
 * since 1.0 */

// original is get_navigation() from 'admin/inc/theme_functions.php'
function makeSub($url,$currentpage,$OA) {
	global $pagesArray;
	$menu = '';
	$pagesSorted = subval_sort($pagesArray,'menuOrder');
	
	// for each page
	if (count($pagesSorted) != 0) { 
		foreach ($pagesSorted as $page) {
			if ($page['menuStatus'] == 'Y' && $page['parent']) { 
				
				// if no menu title / page title
				if (!$page['menu']) { $page['menu'] = $page['title']; }
				if (!$page['title']) { $page['title'] = $page['menu']; }
				
				// if parent found, make <li> and go for sub
				if ($url == $page['parent']) {
					$menu .= liTag($currentpage,$page,$OA,0).'<a href="'. find_url($page['url'],$page['parent']).'"';
					
					// if title is 'none'
					if ($OA['title'] == 'none') $nothing = 'happens';
					else $menu.= ' title="'.strip_quotes($page['title']).'"';
					
					$menu .= '>'.$page['menu'].'</a>';
					
					$makeSub = makeSub($page['url'],$currentpage,$OA);
					if ($makeSub) $menu .= '<ul>'.$makeSub.'</ul>'; 
					
					$menu .= liTag($currentpage,$page,$OA,1);
				}				
			}
		}
	}
	return exec_filter('menuitems',$menu);
}



/* li Tag
 * since 1.0 */

function liTag($currentpage,$page,$OA,$which) {
	
	// check if page is current
	if ($currentpage == $page['url']) { 
		if ($OA['curB']) { $liB = $OA['curB']; $liA = $OA['curA']; } 
		else { $liB = $OA['actB']; $liA = $OA['actA']; }
	} 
	else { 
		$liB = $OA['itemB']; 
		$liA = $OA['itemA'];
	}

	// check if is active
	if ($OA['actB'] && hasActChild($page['url'],$currentpage) == true) {
		$liB = $OA['actB']; 
		$liA = $OA['actA'];
	}

	// if no li defined
	if (!$liB) $liB = '<li>'; $liA = '</li>';
				
	// return li tags
	if ($which == 0) return $liB;
	elseif ($which == 1) return $liA;

}



/* Has Act Child 
 * since 1.0 */

function hasActChild($this,$currentpage) {
	global $pagesArray;
	$pagesSorted = subval_sort($pagesArray,'menuOrder');
	if (count($pagesSorted) != 0) { 
		foreach ($pagesSorted as $page) {
				
				// if there is child fot $this
				if ($page['parent'] == $this) {
				
					// child url
					$child = $page['url'];
					if ($child == $currentpage)
						return true;
					
					if (hasActChild($child,$currentpage) == true)
						return true;
					
				} 
		}
		
	}
	
}



/* Make Breadcrump
 * since 1.0 */

function makeBread($currentpage,$initial,$OA) {
	global $pagesArray;
	$menu = '';
	$pagesSorted = subval_sort($pagesArray,'menuOrder');
	
	// for each page
	if (count($pagesSorted) != 0) { 
		foreach ($pagesSorted as $page) {
			$i = 1; $i <= count($pagesSorted); $i++;
			if ($page['menuStatus'] == 'Y') { 
				if ($currentpage == $page['url']) {
					
				// default item wraps
				if (!$OA['itemB']) { $OA['itemB'] = '<li>'; $OA['itemA'] = '</li>'; }
				if (!$OA['actB']) { $OA['actB'] = $OA['itemB']; $OA['actA'] = $OA['itemA']; }
				if (!$OA['curB']) { $OA['curB'] = $OA['itemB']; $OA['curA'] = $OA['itemA']; }
					
					// if no menu title / page title
					if (!$page['menu']) $page['menu'] = $page['title'];

					if (!$page['title']) $page['title'] = $page['menu'];

					// a tag with href
					if ($initial == 1) 
						$test[$i] = $OA['curB'].'<a href="'.find_url($page['url'],$page['parent']);
					elseif ($initial == 0)
						$test[$i] = $OA['itemB'].'<a href="'.find_url($page['url'],$page['parent']);
						
					// if title is 'none'
					if ($OA['title'] == 'none') $nothing = 'happens';
					else $test[$i].=	'" title="'. strip_quotes($page['title']);						
						
					// a tag and visible text
					if ($initial == 1) 
						$test[$i].= '">'.$page['menu'].'</a>'.$OA['curA'];
					elseif ($initial == 0) 
						$test[$i].= '">'.$page['menu'].'</a>'.$OA['itemA'];
					
					// again for parent
					if ($page['parent']) makeBread($page['parent'],0,$OA);
					
				}
			}
		}
	}
	// echo breadcrump
	print_r($test[$i]);
}





// Print HTML
makeConstant($pathConstant, $configOA);
makePage($pathPage, $configOA, 0);

?>